## dragonegg 2.8

=== Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 	QUIET:=@
 endif
 
-COMMON_FLAGS=-Wall -Wextra -fvisibility=hidden
+COMMON_FLAGS=-Wall -fvisibility=hidden
 CFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cflags)
 CXXFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cxxflags)
