=== debian/changelog ===
dragonegg (2.8-3) unstable; urgency=low

  * Upload to unstable
  * Update of the tags Vcs-Svn & Vcs-Browser
  * Use c++ instead of c++-4.5 for llvm-c++ (Closes: #625893)
  * Allows usage of llvm-gcc-4.5 even if built with different versions of gcc
    it has been built (and display a warning when it is the case). 
    (Closes: #618768)
  * Standards-Version updated to version 3.9.2

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 06 May 2011 23:28:33 +0200

dragonegg (2.8-1) experimental; urgency=low

  * Sync from Ubuntu
  * New upstream release
    * Incompatible plugin version fixed (Closes: #578381)
  * LLVM Packaging team is now the maintainer
  * Add myself to the uploader
  * Standards-Version updated to version 3.9.1
  * Switch to dpkg-source 3.0 (quilt) format

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 14 Feb 2011 00:24:46 +0100

dragonegg (2.8-0ubuntu1) maverick-proposed; urgency=low

  * Final 2.8 release. LP: #632727.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Oct 2010 18:50:58 +0200

dragonegg (2.8~20101006-0ubuntu1) maverick; urgency=low

  * New upstream version, taken from the trunk.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Oct 2010 16:05:42 +0200

dragonegg (2.8~20100921-0ubuntu1) maverick; urgency=low

  * New upstream version, taken from the trunk.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 21 Sep 2010 22:39:41 +0200

dragonegg (2.8~20100911-0ubuntu1) maverick; urgency=low

  * New upstream version, taken from the trunk.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Sep 2010 10:37:04 +0200

dragonegg (2.8~20100907-0ubuntu1) maverick; urgency=low

  * New upstream version, taken from the trunk.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Sep 2010 17:24:30 +0200

dragonegg (2.7-0ubuntu2) maverick; urgency=low

  * Build-depend on llvm-2.7-dev.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 02 Jun 2010 00:22:09 +0200

dragonegg (2.7-0ubuntu1) maverick; urgency=low

  * Upload to maverick.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 21 May 2010 13:22:45 +0200

dragonegg (2.7-0ubuntu1~ppa3) lucid; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 27 Apr 2010 15:09:49 +0200

dragonegg (0~20091229-2) experimental; urgency=low

  * control (llvm-gcc-4.5): Provide and conflict with llvm-gcc.

 -- Robert Millan <rmh.debian@aybabtu.com>  Mon, 04 Jan 2010 13:15:08 +0100

dragonegg (0~20091229-1) experimental; urgency=low

  * Initial release.  (Closes: #563315)

 -- Robert Millan <rmh.debian@aybabtu.com>  Fri, 01 Jan 2010 22:55:02 +0100
