=== debian/control ===
Source: dragonegg
Section: devel
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Arthur Loiret <aloiret@debian.org>, Robert Millan <rmh.debian@aybabtu.com>, Sylvestre Ledru <sylvestre@debian.org>
Build-Depends:
 cdbs,
 debhelper (>= 7),
 gcc-4.5-plugin-dev,
 llvm-2.8-dev (>= 2.8),
 libffi-dev,
 libmpfr-dev,
 libmpc-dev,
Standards-Version: 3.9.2
Homepage: http://dragonegg.llvm.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/dragonegg/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/dragonegg/trunk/

Package: dragonegg
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gcc-4.5 | g++-4.5
Description: GCC plugin that uses LLVM for optimization and code generation
 DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
 and code generators with those from the LLVM project.
 .
 It is a reimplementation of llvm-gcc that works with gcc-4.5 or later.
 .
 DragonEgg is under heavy development and is not mature - it may crash or
 produce wrong code.

Package: llvm-gcc-4.5
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia
Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg, gcc-4.5, g++-4.5
Provides: llvm-gcc
Conflicts: llvm-gcc
Description: C front end for LLVM C/C++ compiler
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs.
 .
 This is the DragonEgg-based version of llvm-gcc.  Note that DragonEgg
 is under heavy development and is not mature - it may crash or
 produce wrong code.
