=== debian/changelog ===
dragonegg (2.9-2build1) unstable; urgency=low

   * Rebuild for changed (old) gcc_lib_dir location.

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 03 Sep 2011 14:50:02 +0200

dragonegg (2.9-2) unstable; urgency=low

  * Fix (probably) the kfreebsd FTBFS (Closes: #635288)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 25 Jul 2011 11:34:20 +0200

dragonegg (2.9-1) unstable; urgency=low

  * New upstream release. Fix build issues. (Closes: #633946) (LP: #770819)
  * Watch file added

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 24 Jul 2011 12:32:35 +0200
