=== debian/control ===
--- 
+++ 
@@ -7,10 +7,11 @@
  cdbs,
  debhelper (>= 7),
  gcc-4.5-plugin-dev,
- llvm-2.8-dev (>= 2.8),
+ llvm-2.9-dev (>= 2.9),
  libffi-dev,
  libmpfr-dev,
  libmpc-dev,
+ subversion
 Standards-Version: 3.9.2
 Homepage: http://dragonegg.llvm.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/dragonegg/trunk/
