=== debian/changelog ===
dragonegg (3.0-1) unstable; urgency=low

  [ Matthias Klose ]
  * New upstream version.
  * Build for gcc-4.6.
  * Linked against the shared libLLVM. 

  [ Sylvestre Ledru ]
  * Switch to dpkg-source 3.0 (quilt) format

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 05 Dec 2011 13:23:18 +0100
