=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends:
  cdbs,
  debhelper (>= 7),
- gcc-4.5-plugin-dev,
- llvm-2.9-dev (>= 2.9),
+ gcc-4.6-plugin-dev,
+ llvm-3.0-dev (>= 3.0),
  libffi-dev,
  libmpfr-dev,
  libmpc-dev,
@@ -20,19 +20,19 @@
 Package: dragonegg
 Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: gcc-4.5 | g++-4.5
+Recommends: gcc-4.6 | g++-4.6
 Description: GCC plugin that uses LLVM for optimization and code generation
  DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
  and code generators with those from the LLVM project.
  .
- It is a reimplementation of llvm-gcc that works with gcc-4.5 or later.
+ It is a reimplementation of llvm-gcc that works with gcc-4.6 or later.
  .
  DragonEgg is under heavy development and is not mature - it may crash or
  produce wrong code.
 
-Package: llvm-gcc-4.5
+Package: llvm-gcc-4.6
 Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia
-Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg, gcc-4.5, g++-4.5
+Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg, gcc-4.6, g++-4.6
 Provides: llvm-gcc
 Conflicts: llvm-gcc
 Description: C front end for LLVM C/C++ compiler
