## dragonegg 3.1

=== Makefile ===
--- 
+++ 
@@ -11,13 +11,23 @@
 
 # Location of this Makefile, useful if you want separate source and object
 # directories.
-TOP_DIR?=$(PWD)
+TOP_DIR?=$(CURDIR)
+
+# Normally the plugin will refuse to load into a different gcc to the one it was
+# built against.  Uncomment this (or pass DISABLE_VERSION_CHECK=1 on the 'make'
+# command line) to disable the check.
+#DISABLE_VERSION_CHECK=1
+
+# Where to find the lit.py script and modules, used for running tests.
+LIT_DIR?=$(shell $(LLVM_CONFIG) --src-root)/utils/lit
+# Where to find LLVM utils, used for running tests.
+LLVM_TOOLS_DIR?=$(shell $(LLVM_CONFIG) --obj-root)/$(shell $(LLVM_CONFIG) --build-mode)/bin/
 
 INCLUDE_DIR=$(TOP_DIR)/include
 SRC_DIR=$(TOP_DIR)/src
 
 ifndef VERBOSE
-	QUIET:=@
+QUIET:=@
 endif
 
 COMMON_FLAGS=-Wall -Wextra -fvisibility=hidden
@@ -35,14 +45,14 @@
 GCC_MAJOR=$(word 1, $(subst ., ,$(GCC_VERSION)))
 GCC_MINOR=$(word 2, $(subst ., ,$(GCC_VERSION)))
 GCC_MICRO=$(word 3, $(subst ., ,$(GCC_VERSION)))
+GCC_LANGUAGES=$(shell $(GCC) -v 2>&1 | grep '^Configured with:' | sed 's/^.*--enable-languages=\([^ ]*\).*/\1/')
 TARGET_TRIPLE:=$(shell $(GCC) -dumpmachine)
 
-# NOTE: replace with an informative string when doing a release.
-REVISION:=$(shell svnversion -n $(TOP_DIR))
+LLVM_VERSION:=$(shell $(LLVM_CONFIG) --version)
 
 PLUGIN=dragonegg.so
-PLUGIN_OBJECTS=Backend.o Cache.o Constants.o Convert.o Debug.o DefaultABI.o \
-	       Trees.o Types.o bits_and_bobs.o
+PLUGIN_OBJECTS=Aliasing.o Backend.o Cache.o Constants.o Convert.o Debug.o \
+	       DefaultABI.o Trees.o Types.o bits_and_bobs.o
 
 TARGET_OBJECT=Target.o
 TARGET_SOURCE=$(SRC_DIR)/$(shell $(TARGET_UTIL) -p)/Target.cpp
@@ -54,10 +64,13 @@
 
 CPP_OPTIONS+=$(CPPFLAGS) $(shell $(LLVM_CONFIG) --cppflags) \
 	     -MD -MP \
-	     -DIN_GCC -DREVISION=\"$(REVISION)\" \
+	     -DIN_GCC -DLLVM_VERSION=\"$(LLVM_VERSION)\" \
 	     -DGCC_MAJOR=$(GCC_MAJOR) -DGCC_MINOR=$(GCC_MINOR) \
 	     -DGCC_MICRO=$(GCC_MICRO) \
-	     -I$(INCLUDE_DIR) -I$(GCC_PLUGIN_DIR)/include
+	     -I$(INCLUDE_DIR) -isystem$(GCC_PLUGIN_DIR)/include
+ifdef DISABLE_VERSION_CHECK
+CPP_OPTIONS+=-DDISABLE_VERSION_CHECK
+endif
 
 LD_OPTIONS+=$(shell $(LLVM_CONFIG) --ldflags) $(LDFLAGS)
 
@@ -66,6 +79,15 @@
 		-I$(INCLUDE_DIR)/$(shell $(TARGET_UTIL) -p) \
 		-I$(INCLUDE_DIR)/$(shell $(TARGET_UTIL) -o)
 
+ifdef VERBOSE
+LIT_ARGS+=-v
+else
+LIT_ARGS+=-s -v
+endif
+
+LIT_SITE_CONFIG=test/dragonegg-lit.site.cfg
+TEST_SRC_DIR=$(TOP_DIR)/test
+export PYTHONPATH:=$(TEST_SRC_DIR):$(LIT_DIR)/lit:$(PYTHONPATH)
 
 default: $(PLUGIN)
 
@@ -95,8 +117,32 @@
 	analysis core ipo scalaropts target $(shell $(TARGET_UTIL) -p)) \
 	$(LD_OPTIONS)
 
+$(LIT_SITE_CONFIG): $(TEST_SRC_DIR)/dragonegg-lit.site.cfg.in
+	@echo "Making DragonEgg '$@' file..."
+	$(QUIET)mkdir -p test
+	$(QUIET)echo s=@DRAGONEGG_PLUGIN@=$(CURDIR)/$(PLUGIN)=g > lit.tmp
+	$(QUIET)echo s=@GCC@=$(GCC)=g >> lit.tmp
+	$(QUIET)echo s=@GCC_LANGUAGES@=$(GCC_LANGUAGES)=g >> lit.tmp
+	$(QUIET)echo s=@LLVM_TOOLS_DIR@=$(LLVM_TOOLS_DIR)=g >> lit.tmp
+	$(QUIET)echo s=@TARGET_TRIPLE@=$(TARGET_TRIPLE)=g >> lit.tmp
+	$(QUIET)echo s=@TEST_OUTPUT_DIR@=$(CURDIR)/test/Output=g >> lit.tmp
+	$(QUIET)sed -f lit.tmp $< > $@
+	$(QUIET)-rm -f lit.tmp
+
+check-compilator:: $(PLUGIN) $(LIT_SITE_CONFIG)
+	@echo "Running test suite 'compilator'"
+	$(QUIET)$(LIT_DIR)/lit.py $(LIT_ARGS) --param site="$(LIT_SITE_CONFIG)" \
+	--config-prefix=dragonegg-lit $(TEST_SRC_DIR)/compilator
+
+check-validator:: $(PLUGIN) $(LIT_SITE_CONFIG)
+	@echo "Running test suite 'validator'"
+	$(QUIET)$(LIT_DIR)/lit.py $(LIT_ARGS) --param site="$(LIT_SITE_CONFIG)" \
+	--config-prefix=dragonegg-lit $(TEST_SRC_DIR)/validator
+
+check:: check-validator check-compilator
+
 clean::
-	$(QUIET)rm -f *.o *.d $(PLUGIN) $(TARGET_UTIL)
+	$(QUIET)rm -f *.o *.d $(PLUGIN) $(TARGET_UTIL) $(LIT_SITE_CONFIG)
 
 
 -include $(ALL_OBJECTS:.o=.d)
