=== debian/changelog ===
dragonegg (3.1-2ubuntu1) quantal; urgency=low

  * Use GCC 4.7 by default.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 12 Sep 2012 17:23:41 +0200

dragonegg (3.1-2) unstable; urgency=low

  [ Vincent Legout ]
  * debian/rules: Build with DISABLE_VERSION_CHECK=1 to be able to use a
    different gcc version that the one dragonegg was built against.
    (Closes: #679914)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 15 Jul 2012 23:29:32 +0200

dragonegg (3.1-1) unstable; urgency=low

  * New upstream release
  * Introduce new dragonegg packages to manage both gcc 4.6 & 4.7:
    - dragonegg-4.6 & llvm-gcc-4.6
    - dragonegg-4.7 & llvm-gcc-4.7
    The package dragonegg will install version 4.6

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 30 May 2012 15:32:20 +0200

dragonegg (3.0-3.2) unstable; urgency=low

  * Build-depend on g++-4.6.

 -- Matthias Klose <doko@debian.org>  Wed, 23 May 2012 00:27:00 +0000

dragonegg (3.0-3.1) unstable; urgency=low

  * Non maintainer upload
  * Explicitly build using GCC 4.6. Closes: #667153.

 -- Matthias Klose <doko@debian.org>  Tue, 22 May 2012 23:42:58 +0000

dragonegg (3.0-3) unstable; urgency=low

  * Standards-Version updated to version 3.9.3
  * Update of the uploader list
  * Support of arm. Thanks to Matthias Klose for the patch
  * Enhance the error message (LP: #923349, #941407) (Closes: #656616)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 06 Mar 2012 22:31:11 +0100

dragonegg (3.0-2) unstable; urgency=low

  * Install of llvm-gcc-4.6 removes llvm-gcc-4.5 (Closes: #656610)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 17 Feb 2012 13:09:28 +0100
