=== debian/control ===
Source: dragonegg
Section: devel
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Robert Millan <rmh.debian@aybabtu.com>, Sylvestre Ledru <sylvestre@debian.org>
Build-Depends:
 cdbs,
 debhelper (>= 7),
 gcc-4.6-plugin-dev,
 gcc-4.7-plugin-dev,
 g++-4.6,
 g++-4.7,
 llvm-3.1-dev (>= 3.1),
 libffi-dev,
 libmpfr-dev,
 libmpc-dev,
 subversion
Standards-Version: 3.9.3
Homepage: http://dragonegg.llvm.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/dragonegg/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/dragonegg/trunk/

Package: dragonegg
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg-4.7
Description: GCC plugin that uses LLVM for optimization and code generation
 DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
 and code generators with those from the LLVM project.
 .
 It is a reimplementation of llvm-gcc that works with gcc-4.6 or later.
 .
 DragonEgg is under heavy development and is not mature - it may crash or
 produce wrong code.

Package: dragonegg-4.6
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gcc-4.6 | g++-4.6
Replaces: dragonegg (<< 3.1)
Breaks: dragonegg (<< 3.1)
Description: GCC plugin that uses LLVM for optimization and code generation
 DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
 and code generators with those from the LLVM project.
 .
 It is a reimplementation of llvm-gcc that works with gcc-4.6 or later.
 .
 DragonEgg is under heavy development and is not mature - it may crash or
 produce wrong code.

Package: dragonegg-4.7
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gcc-4.7 | g++-4.7
Description: GCC plugin that uses LLVM for optimization and code generation
 DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
 and code generators with those from the LLVM project.
 .
 It is a reimplementation of llvm-gcc that works with gcc-4.6 or later.
 .
 DragonEgg is under heavy development and is not mature - it may crash or
 produce wrong code.

Package: llvm-gcc-4.6
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg-4.6, gcc-4.6, g++-4.6
Provides: llvm-gcc
Conflicts: llvm-gcc, llvm-gcc-4.5
Replaces: llvm-gcc-4.5
Description: C front end for LLVM C/C++ compiler
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs.
 .
 This is the DragonEgg-based version of llvm-gcc. 


Package: llvm-gcc-4.7
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg-4.7, gcc-4.7, g++-4.7
Description: C front end for LLVM C/C++ compiler
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs.
 .
 This is the DragonEgg-based version of llvm-gcc.
