=== debian/changelog ===
dragonegg (3.2-1~exp1ubuntu2) raring; urgency=low

  * No change rebuild for GCC 4.7.3 and 4.6.4.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 16 Apr 2013 00:03:49 +0200

dragonegg (3.2-1~exp1ubuntu1) raring; urgency=low

  * Remove build dependency bloat on subversion.
  * Link with the shared llvm library.
  * Default dragonegg to dragonegg-4.7.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 08 Feb 2013 04:29:16 +0100

dragonegg (3.2-1~exp1) experimental; urgency=low

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 21 Dec 2012 08:48:56 +0100

dragonegg (3.2~rc3-1~exp1) experimental; urgency=low

  * New testing release

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 06 Dec 2012 15:22:19 +0100

dragonegg (3.2~rc2-1~exp1) experimental; urgency=low

  * New testing release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 04 Dec 2012 20:43:40 +0100

Bdragonegg (3.1-2) unstable; urgency=low

  [ Vincent Legout ]
  * debian/rules: Build with DISABLE_VERSION_CHECK=1 to be able to use a
    different gcc version that the one dragonegg was built against.
    (Closes: #679914)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 15 Jul 2012 23:29:32 +0200
