=== debian/control ===
--- 
+++ 
@@ -7,14 +7,13 @@
  cdbs,
  debhelper (>= 7),
  gcc-4.6-plugin-dev,
- gcc-4.7-plugin-dev,
+ gcc-4.7-plugin-dev (>= 4.7.2-10),
  g++-4.6,
- g++-4.7,
- llvm-3.1-dev (>= 3.1),
+ g++-4.7 (>= 4.7.2-10),
+ llvm-3.2-dev (>= 3.2),
  libffi-dev,
  libmpfr-dev,
- libmpc-dev,
- subversion
+ libmpc-dev
 Standards-Version: 3.9.3
 Homepage: http://dragonegg.llvm.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/dragonegg/trunk/
@@ -36,8 +35,8 @@
 Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: gcc-4.6 | g++-4.6
-Replaces: dragonegg (<< 3.1)
-Breaks: dragonegg (<< 3.1)
+Replaces: dragonegg (<< 3.2)
+Breaks: dragonegg (<< 3.2)
 Description: GCC plugin that uses LLVM for optimization and code generation
  DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
  and code generators with those from the LLVM project.
