=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #!/usr/bin/make -f
-LLVM_VERSION = 3.1
+LLVM_VERSION = 3.2
 GCC_VERSION = 4.6
 GCC_VERSION_NEXT = 4.7
